#!/usr/bin/ruby

require 'plist'

$file

def convert_color_books_to_plists()
	def skip_file_header
		$file.seek(8) 
	end
	
	def skip_title() 
		title_length = $file.read(4).unpack("N").first * 2 #skip tile
 		$file.seek(title_length, IO::SEEK_CUR)
	end
	
	def skip_prefix()
		 prefix_length = $file.read(4).unpack("N").first * 2 #skip prefix
 		$file.seek(prefix_length, IO::SEEK_CUR)
	end
	
	def skip_postfix()
  		postfix_length = $file.read(4).unpack("N").first * 2 #skip postfix
 		$file.seek(postfix_length, IO::SEEK_CUR)
	end
	
	def skip_description()
		 description_length = $file.read(4).unpack("N").first * 2 #skip_description
 		$file.seek(description_length, IO::SEEK_CUR)
	end
	
	def skip_page_information()
 		$file.seek(4, IO::SEEK_CUR)
	end
	
	def skip_color_name
		color_name_length = $file.read(4).unpack("N").first * 2	
 		$file.seek(color_name_length, IO::SEEK_CUR)
	end
	
	def read_colors(number_of_colors, color_type)
		 colors = Hash.new
		 
		 for i in 0..(number_of_colors - 1)
		 	color = Hash.new
			skip_color_name
			color['colorModel'] = color_type
			color_key = $file.read(6)
			
			if color_type == 7
				color['w'] = $file.read(1).unpack("C").first
				color['x'] = $file.read(1).unpack("C").first
				color['y'] = $file.read(1).unpack("C").first
			else
				color['w'] = $file.read(1).unpack("C").first
				color['x'] = $file.read(1).unpack("C").first
				color['y'] = $file.read(1).unpack("C").first
				color['z'] = $file.read(1).unpack("C").first
			end
			colors[color_key.to_s] = color
		end
		
		return colors
	end

	directory_name = "plists"
	Dir.mkdir(directory_name) unless File.exists?(directory_name)

	map = Hash.new
	Dir['./*.acb'].each do |file_name|
	  next if File.directory? file_name 
  
 		$file = File.open(file_name, "r")

		skip_file_header()
		skip_title()
 		skip_prefix()
 		skip_postfix()
 		skip_description()
 		number_of_colors = $file.read(2).unpack("n").first
		skip_page_information()
 		color_type = $file.read(2).unpack("n").first
 		
 		colors = read_colors(number_of_colors, color_type)

		colors.save_plist(directory_name + '/' + File.basename(file_name, '.acb') + '.plist')
		
		$file.close 
	end
	
	return map
end

convert_color_books_to_plists()
