#!/usr/bin/ruby

require 'plist'

def create_book_file_map()
	map = Hash.new
	Dir['./*.acb'].each do |file_name|
	  next if File.directory? file_name 
  
		file = File.open(file_name, "r")
		file_signature = file.read(4)
		version = file.read(2).unpack("n").first
		book_id = file.read(2).unpack("n").first

		if version == 1 && file_signature == '8BCB'
			map[book_id.to_s] =  File.basename(file_name, '.acb')
		end
	
		file.close 
	end
	
	return map
end

map = create_book_file_map()
map.save_plist('bookMap.plist')
